#!/bin/sh
synolra=../linux-dsx14j-3.2.40-22259
synofab=88f6180
synolvb=mainline

for b in `cat branch-list.txt` ; do
  synolra=../linux-dsx14j-3.2.40-22259
  synofam=comcerto2k
  synolxa=3.2.40
  synolva=${b}

  if [ ${synolva} -lt 2636 ]; then
    synolxa=2.6.32
  elif [ ${synolva} -lt 3200 ]; then
    synolxa=3.2.11
  elif [ ${synolva} -lt 3700 ]; then
    synolxa=3.2.30
  fi

  if [ ${synofab} = qoriq -o ${synofab} = 853x -o ${synofab} = 854x -o ${synofab} = 88f6180 ]; then
    synolxa=2.6.32
  fi

  if [ ${synolva} -lt 2636 ]; then
    synolra=../linux-ds211-2.6.32-22259
    synofam=88f628x
  elif [ ${synolva} -lt 3203 ]; then
    synofam=x64
  elif [ ${synolva} -lt 4450 ]; then
    synofam=armada370
  fi

  if [ ${synolxa} = 2.6.32 ]; then
    synolra=../linux-ds211-2.6.32-22259
    synofam=88f628x 
  fi

  echo ""
  v=${synolxa}
  u=https://seafile.servator.de/nas/synology/unmodified/${synofab}/${b}/linux-${v}.tar.xz
  d=linux-${v}-${b}-unpatched
  e=${d}

  echo $u
  if [ ! -e linux-${v}-${b}.tar.xz ]; then
    if wget -N $u ; then
      mv linux-${v}.tar.xz linux-${v}-${b}.tar.xz
    fi
  fi
  if [ -e linux-${v}-${b}.tar.xz -a ! -e linux-${v}-${b}-unpatched ]; then
    echo "Unpacking..."
    tar xJf linux-${v}-${b}.tar.xz
    mv linux-${v} linux-${v}-${b}-unpatched
  fi

  p=linux-${synolxa}-${synolva}-${synofam}-to-${synofab}.patch
  w=linux-${synolxa}-${synolva}-${synofam}-to-${synofab}-wbB.patch
  q=linux-${synolxa}-${synolva}-${synofam}-to-${synofab}-extra.patch

  changerevs=false
  restoredefs=false
  if [ ${synolva} = 5004 -o ${synolva} = 25426 ]; then
    restoredefs=true
  fi
  removedefs=false

  if [ -e linux-${v}-${b}-unpatched -a ${synofam} != ${synofab} -a ! -e ${p} ]; then
    echo "Creating ${p}"
    ln -s ${synolra}/${e} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${p} || true
    rm a
    rm b
  fi

  w=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-wbB-v2.patch
  if [ -e linux-${v}-${b}-unpatched -a ${synofam} != ${synofab} -a ! -e ${w} ]; then
    if [ $restoredefs = true -o $removedefs = true ]; then
    echo "Creating ${w}"
    ln -s ${synolra}/${e} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -wbBur a b > ${w} || true
    rm a
    rm b
    fi
  fi

  if [ -e ${p} -a ! -e ${q} ]; then
    if grep -q '^Nur in b/' ${p} ; then
      echo "Creating ${q}"
      ln -s ${synolra}/${e} a
      ln -s ${d} b
      grep '^Nur in b/' ${p} | grep -v gitignore | cut -d / -f 2- | sed "s|: |/|g" | sed s/'\.$'/''/g | while read f ; do
        diff -uN a/$f b/$f >> ${q} || true
      done
      rm a
      rm b
    fi
  fi

  c=linux-${v}-${synolva}-patched0n
  r=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-restore-defines.patch
  if [ -e ${w} -a $restoredefs = true ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${d}/. ${c}/
    fi
      grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- > _defabc-${synolvb}-files.txt
      echo "Modifying defines..."
      sh mod-defs.sh ${c} _defabc-${synolvb}
      sh add-abc-defs.sh ${c} ${w} -r
    #fi

    if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${r} ]; then
      echo "Creating ${r}"
      ln -s ${c} a
      ln -s ${d} b
      rm -f a/include/linux/version.h
      rm -f b/include/linux/version.h
      diff -ur a b > ${r} || true
      rm a
      rm b
    fi

    #synolra=.
    d=${c}
  fi

  c=linux-${v}-${b}-patched1
  if [ -e ${w} ]; then
    echo "Creating ${c}"
    if [ ! -e ${c} ]; then
      mkdir ${c}
      cp -apP ${synolra}/${e}/. ${c}/
    fi
    echo "Copying changed files..."
    grep -E '^\+\+\+' ${w} | cut -f 1 | cut -d / -f 2- | while read f ; do
      #echo $f
      cp -p ${d}/$f ${c}/$f
    done
    #grep '^Nur in ' ${w} | cut -d / -f 2- | sed "s|: |/|g" | sed s/'\.$'/''/g | while read f ; do
    #  echo "rm $f"
    #done
  fi

  o=${p}
  p=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-v2.patch
  if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${p} ]; then
    echo "Creating ${p}"
    ln -s ${synolra}/${e} a
    ln -s ${c} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${p} || true
    rm a
    rm b
  fi

  s=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-whitespace.patch
  if [ $changerevs = true ]; then
    s=linux-${synolxa}-${synofab}-${synolvb}-to-${synolva}-change-revisions.patch
  fi
  if [ -e ${c} -a ${synofam} != ${synofab} -a ! -e ${s} ]; then
    echo "Creating ${s}"
    ln -s ${c} a
    ln -s ${d} b
    rm -f a/include/linux/version.h
    rm -f b/include/linux/version.h
    diff -ur a b > ${s} || true
    rm a
    rm b
  fi

  synolvb=${synolva}
done

echo OK
